Index: trunk/kernel/drivers/ibmpc/tty.c
===================================================================
--- trunk/kernel/drivers/ibmpc/tty.c	(revision 1)
+++ trunk/kernel/drivers/ibmpc/tty.c	(revision 1)
@@ -0,0 +1,520 @@
+/*
+ * tty.c - a basic tty driver
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <system.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <cpu-io.h>
+#include <kmem.h>
+#include <libk.h>
+#include <tty.h>
+#include <rwlock.h>
+#include <cpu-trace.h>
+#include <thread.h>
+#include <mwmr.h>
+
+struct device_s ttys_tbl[TTY_DEV_NR];
+
+static void tty_clear(struct device_s *tty)
+{
+	register uint_t i = 0;
+	struct tty_context_s *ctx;
+	uint8_t *vga_ram;
+
+	ctx = (struct tty_context_s*)tty->data;
+	vga_ram = (uint8_t*)tty->base;
+
+	for(i = 0; i < TTY_SIZE; i+=2)
+	{
+		vga_ram[i] = 0;
+		vga_ram[i+1] = ctx->attr;
+	}
+}
+
+
+static sint_t tty_read(struct device_s *tty, dev_request_t *rq)
+{
+	struct tty_context_s *ctx; 
+	register size_t size;
+	uint_t irq_state;
+	register char *dst;
+	register size_t count;
+	register uint32_t eol = 0;
+   
+	cpu_trace_write(CURRENT_THREAD->local_cpu, tty_read);
+
+	ctx = (struct tty_context_s*)tty->data;
+	size = 0;
+	count = rq->count;
+	dst = rq->dst;
+   
+	if(rq->flags & DEV_RQ_NOBLOCK)
+		rwlock_rdlock(&ctx->rwlock);
+	else
+		rwlock_wrlock(&ctx->rwlock);
+
+	spinlock_lock_noirq(&tty->lock, &irq_state);
+
+	size = mwmr_read(ctx->in_channel, dst, count);
+	eol = ctx->eol;
+   
+	if((eol) || (size == count) || (rq->flags & DEV_RQ_NOBLOCK))
+	{
+		ctx->eol = 0;
+		spinlock_unlock_noirq(&tty->lock, irq_state);
+		rwlock_unlock(&ctx->rwlock);
+		return size;
+	}
+
+	rq->count -= size;
+	rq->dst = dst + size;
+	ctx->pending_rq = rq;
+
+	wait_on(&ctx->wait_queue, WAIT_LAST);
+	spinlock_unlock_noirq(&tty->lock, irq_state);
+	sched_sleep(CURRENT_THREAD);
+	rwlock_unlock(&ctx->rwlock);
+	return count - rq->count;
+}
+
+void tty_scrollup(struct device_s *tty, int n)
+{
+	struct tty_context_s *ctx;
+	uint8_t *vga_ram;
+	uint8_t *ptr;
+	uint8_t *limit = (uint8_t*)((uint_t)TTY_SIZE);
+
+	ctx = (struct tty_context_s*)tty->data;
+	vga_ram = (uint8_t*)tty->base;
+
+	for(; vga_ram < limit; vga_ram+=2)
+	{
+		ptr=&vga_ram[n*2*TTY_XSIZE];
+    
+		if(ptr < limit) 
+		{
+			*vga_ram = *ptr;
+			*(vga_ram + 1) = *(ptr+1);
+		}
+		else
+		{
+			*vga_ram = 0;
+			*(vga_ram+1) = 0x07;
+		}
+	}
+  
+	ctx->pos_Y -= n;
+	ctx->pos_Y = (ctx->pos_Y < 0) ? 0 : ctx->pos_Y;
+}
+
+static void tty_cleanup(struct device_s *tty)
+{
+	struct tty_context_s *ctx;
+
+	ctx = (struct tty_context_s*)tty->data;
+	tty_clear(tty);
+	ctx->pos_Y = 0;
+	ctx->pos_X = 0;
+}
+
+#define TTY_CURSOR_CMD        0x3d4
+#define TTY_CURSOR_DATA       0x3d5
+
+void tty_move_cursor(uint_t pos_X, uint_t pos_Y)
+{
+	uint_t pos;
+
+	pos = pos_Y * TTY_XSIZE + pos_X;
+	cpu_io_out8(TTY_CURSOR_CMD, 0x0f);
+	cpu_io_out8(TTY_CURSOR_DATA, pos);
+	cpu_io_out8(TTY_CURSOR_CMD, 0x0e);
+	cpu_io_out8(TTY_CURSOR_DATA, pos >> 8);
+}
+
+static void tty_putc(struct device_s *tty, uint8_t ch)
+{
+	struct tty_context_s *ctx;
+	uint8_t *vga_ram;
+	int offset;
+
+	ctx = (struct tty_context_s*)tty->data;
+	vga_ram = (uint8_t*)tty->base;
+
+	switch (ch)
+	{
+	case '\b':
+		ctx->pos_X --;
+		break;
+	case '\t':
+		ctx->pos_X += 8;
+		break;
+
+	case '\r':
+		ctx->pos_X = 0;
+		break;
+
+	case '\n':	
+		ctx->pos_X = 0;
+		ctx->pos_Y ++;
+		break;
+  
+	default:
+		offset = 2*TTY_XSIZE*ctx->pos_Y + 2*ctx->pos_X;
+		ctx->pos_X++;
+		vga_ram[offset] = ch;
+		vga_ram[offset + 1] = (uint8_t)(ctx->attr & 0xFF);
+	}
+
+	if(ctx->pos_X >= TTY_XSIZE)
+	{
+		ctx->pos_X = 0;
+		ctx->pos_Y ++;
+	}
+  
+#if 1
+	if(ctx->pos_Y >= TTY_YSIZE)
+	{
+		tty_cleanup(tty);
+		//ctx->pos_Y = 0;
+	}
+#endif
+}
+
+
+static sint_t tty_write(struct device_s *tty, dev_request_t *rq)
+{
+	struct tty_context_s *ctx; 
+	register unsigned int i;
+	register size_t size = rq->count;
+  
+	cpu_trace_write(CURRENT_THREAD->local_cpu, tty_write);
+  
+	ctx = (struct tty_context_s*)tty->data;
+  
+	if(!(rq->flags & DEV_RQ_NOBLOCK))
+		rwlock_wrlock(&ctx->rwlock);
+
+	for (i = 0; i < size; i++)
+		tty_putc(tty, *((uint8_t*)rq->src + i));
+
+	if(!(rq->flags & DEV_RQ_NOBLOCK))
+		rwlock_unlock(&ctx->rwlock);
+
+	return size;
+}
+
+
+static sint_t tty_get_params(struct device_s *tty, dev_params_t *params)
+{
+	params->chr.xSize = TTY_XSIZE;
+	params->chr.ySize = TTY_YSIZE;
+	params->size = 0;
+	return 0;
+}
+
+#define KEYBOARD_READ_REG     0x60
+#define KEYBOARD_WRITE_REG    0x60
+#define KEYBOARD_STATUS_REG   0x64
+#define KEYBORAD_CMD_REG      0x64
+
+#define KEY_IS_HOLD           0x80
+#define KEY_IS_LEFT_SHIFT     0x29
+#define KEY_IS_RIGHT_SHIFT    0x35
+#define KEY_IS_ALT            0x37
+#define KEY_IS_CTRL           0x1C
+#define KEY_IS_CAPSLOCK       0x39
+
+static uint_t isLeftShift;
+static uint_t isRightShift;
+static uint_t isAlt;
+static uint_t isCtrl;
+static uint_t isCAPSLOCK;
+
+static error_t tty_getc(struct device_s *tty)
+{
+	register uint8_t isUpper;
+	register uint8_t scode;
+	register error_t ch;
+	ch = -1;
+	scode = 0;
+
+	/* Waite KEYBOARD OUTPUT BUFFER */
+	do
+	{
+		scode = cpu_io_in8(KEYBOARD_STATUS_REG);
+	}while((scode & 0x1) == 0);
+    
+	scode = cpu_io_in8(KEYBOARD_READ_REG);
+	scode --;
+  
+	//  isr_dmsg(DEBUG, "scode %x\n", scode);
+  
+	if(scode < KEY_IS_HOLD)
+	{
+		switch (scode)
+		{
+		case KEY_IS_RIGHT_SHIFT:
+			isRightShift = 1;
+			break;
+		case KEY_IS_CTRL:
+			isCtrl = 1;
+			break;
+		case KEY_IS_ALT:
+			isAlt = 1;
+			break;
+		case KEY_IS_CAPSLOCK:
+			break;
+		case KEY_IS_LEFT_SHIFT:
+			isLeftShift = 1;
+			break;
+		default:
+			isUpper = (isRightShift || isLeftShift || isCAPSLOCK) ? 1 : 0;
+			ch = keyboard_map[(scode << 2) + isUpper + isAlt];
+		}
+	}
+	else
+	{
+		scode -= 0x80;
+		switch (scode)
+		{
+		case KEY_IS_RIGHT_SHIFT:
+			isRightShift = 0;
+			break;
+		case KEY_IS_CTRL:
+			isCtrl = 0;
+			break;
+		case KEY_IS_ALT:
+			isAlt = 0;
+			break;
+		case KEY_IS_CAPSLOCK:
+			isCAPSLOCK = (isCAPSLOCK) ? 0 : 1;
+			break;
+		case KEY_IS_LEFT_SHIFT:
+			isLeftShift = 0;
+			break;
+		default:
+			/* No action for other scan code */
+			break;
+		}
+	}
+  
+	struct tty_context_s *ctx = tty->data;
+	tty_move_cursor(ctx->pos_X, ctx->pos_Y);
+	return ch;
+}
+
+static void tty_irq_handler(struct irq_action_s *action)
+{
+	sint_t ch;
+	struct device_s *tty;
+	struct tty_context_s *ctx; 
+	register char *dst;
+	volatile uint32_t *base;
+   
+	cpu_trace_write(CURRENT_THREAD->local_cpu, tty_irq_handler);
+
+	tty = action->dev;
+	base = tty->base;
+	ctx = (struct tty_context_s*)tty->data;
+
+	if((ch = tty_getc(tty)) & 0x80)
+		return;
+
+	cpu_spinlock_lock(&tty->lock.val);
+
+	if(ctx->pending_rq != NULL)
+	{
+		dst = ctx->pending_rq->dst;
+		*(dst ++) = ch;
+		ctx->pending_rq->dst = dst;
+		ctx->pending_rq->count --;
+
+		if((ch == '\n') || (ctx->pending_rq->count == 0))
+		{
+			wakeup_one(&ctx->wait_queue, WAIT_FIRST);
+			ctx->pending_rq = NULL;
+		}
+	}
+	else
+	{
+		mwmr_write(ctx->in_channel, &ch, 1);
+		if(ch == '\n') ctx->eol = 1;
+	}
+
+#if CONFIG_TTY_ECHO_MODE
+	switch(ch)
+	{
+	case '\b':
+	case 0x7F:
+		tty_putc(tty, '\b');
+	tty_putc(tty, ' ');
+	tty_putc(tty, '\b');
+	break;
+	default:
+		tty_putc(tty, ch);
+	}
+#endif
+
+	cpu_spinlock_unlock(&tty->lock.val);
+}
+
+void ibmpc_tty_init(struct device_s *tty, void *base, uint_t irq, uint_t tty_id)
+{
+	struct tty_context_s *ctx;
+  
+	isRightShift = 0;
+	isLeftShift = 0;
+	isCtrl = 0;
+	isAlt = 0;
+	isCAPSLOCK = 0;
+
+	spinlock_init(&tty->lock);
+	tty->base = base;
+	tty->irq = irq;
+	tty->type = DEV_CHR;
+
+	tty->action.dev = tty;
+	tty->action.irq_handler = &tty_irq_handler;
+	tty->action.data = NULL;
+ 
+	tty->op.dev.open = NULL;
+	tty->op.dev.read = &tty_read;
+	tty->op.dev.write = &tty_write;
+	tty->op.dev.close = NULL;
+	tty->op.dev.lseek = NULL;
+	tty->op.dev.set_params = NULL;
+	tty->op.dev.get_params = &tty_get_params;
+
+	ctx = kbootMem_calloc(sizeof(*ctx));
+	ctx->id = tty_id;
+	ctx->in_channel = mwmr_init(1,TTY_BUFFER_DEPTH, 0);
+	rwlock_init(&ctx->rwlock);
+	ctx->eol = 0;
+	ctx->attr = 0x07;
+	tty->data = (void*) ctx;
+	sprintk(tty->name, "TTY%d", tty_id);
+	metafs_init(&tty->node, tty->name);
+	wait_queue_init(&ctx->wait_queue,tty->name);
+	tty_clear(tty);
+}
+
+
+uint8_t keyboard_map[] = { 0x1B, 0x1B, 0x1B, 0x1B,
+			   '&', '1', '1', '1',
+			   '~', '2', '2', '2',
+			   '"', '3', '3', '3',
+			   '\'','4', '{', '{',
+			   '(', '5', '5', '5',
+			   '-', '6', '|', '|',
+			   '`', '7', '7', '7',
+			   '_', '8', '\\', '\\',
+			   '^', '9', '9', '9',
+			   '@', '0', '0', '0',
+			   ')', ']', '-', '-',
+			   '=', '+', '}','}',
+			   '\b','\b', 0x7F,'\b',
+			   '\t','\t','\t','\t',
+			   'a', 'A', 'a', 'a',
+			   'z', 'Z', 'z', 'z',
+			   'e', 'E', 'e', 'e',
+			   'r', 'R', 'r', 'r',
+			   't', 'T', 't', 't',
+			   'y', 'Y', 'y', 'y',
+			   'u', 'U', 'u', 'u',
+			   'i', 'I', 'i', 'i',
+			   'o', 'O', 'o', 'o',
+			   'p', 'P', 'p', 'p',
+			   '[', '{', '[', '[',
+			   '$', '$', '$', ']',
+			   '\n','\n','\n','\n',
+			   0xFF, 0xFF, 0xFF, 0xFF,
+			   'q', 'A', 'a', 'a',
+			   's', 'S', 's', 's',
+			   'd', 'D', 'd', 'd',
+			   'f', 'F', 'f', 'f',
+			   'g', 'G', 'g', 'g',
+			   'h', 'H', 'h', 'h',
+			   'j', 'J', 'j', 'j',
+			   'k', 'K', 'k', 'k',
+			   'l', 'L', 'l', 'l',
+			   'm', 'M', ';', ';',
+			   '%', '%', '%', '%',
+			   0x28, 0x28, 0x28, 0x28,
+			   0x29, 0x29, 0x29, 0x29, /* Left Shift (41) */
+			   '*', '*', '*', '*',
+			   'w', 'W', 'w', 'w',
+			   'x', 'X', 'x', 'x',
+			   'c', 'C', 'c', 'c',
+			   'v', 'V', 'v', 'v',
+			   'b', 'B', 'b', 'b',
+			   'n', 'N', 'n', 'n',
+			   ',', '?', ',', ',',
+			   ';', '.', ';', ';',
+			   ':', '/', ':', ':',
+			   '!', '!', '!', '!',
+			   0x35, 0x35, 0x35, 0x35,	/*      Rshift  (0x35)  */
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   ' ', ' ', ' ', ' ',	        /*      space   */
+			   0x39, 0x39, 0x39, 0x39,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF, /* 0x40 */	
+			   0xFF, 0xFF, 0xFF, 0xFF, 
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF, /* 0x50 */
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   '<', '>', '<', '<',
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF,	
+			   0xFF, 0xFF, 0xFF, 0xFF, /* 0x60 */
+			   0xFF, 0xFF, 0xFF, 0xFF};
Index: trunk/kernel/drivers/ibmpc/tty.h
===================================================================
--- trunk/kernel/drivers/ibmpc/tty.h	(revision 1)
+++ trunk/kernel/drivers/ibmpc/tty.h	(revision 1)
@@ -0,0 +1,55 @@
+/*
+ * tty.c - a basic tty driver
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _TTY_H_
+#define _TTY_H_
+
+#include <driver.h>
+#include <scheduler.h>
+#include <rwlock.h>
+
+#define TTY_STATUS_REG  0
+#define TTY_READ_REG    1
+#define TTY_WRITE_REG   2
+
+struct device_s;
+struct fifomwmr_s;
+
+void ibmpc_tty_init(struct device_s *tty, void *base, uint_t irq, uint_t tty_id);
+
+struct thread_s;
+
+struct tty_context_s
+{
+	uint_t pos_X, pos_Y;
+	uint_t attr;
+	uint_t id;
+	dev_request_t *pending_rq;
+	unsigned int eol;		/* End Of Line */
+	struct rwlock_s rwlock;
+	struct wait_queue_s wait_queue;
+	struct fifomwmr_s *in_channel;
+	struct fifiomwmr_s *out_channel;
+};
+
+extern uint8_t keyboard_map[];
+#endif	/* _TTY_H_ */
Index: trunk/kernel/drivers/soclib/drvdb.c
===================================================================
--- trunk/kernel/drivers/soclib/drvdb.c	(revision 1)
+++ trunk/kernel/drivers/soclib/drvdb.c	(revision 1)
@@ -0,0 +1,109 @@
+/*
+ * drvdb.c - Dictionary of supported devices and associated drivers
+ *
+ * Authors Ghassan Almaless (2008,2009,2010,2011,2012)
+ *         Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <errno.h>
+#include <libk.h>
+#include <event.h>
+#include <device.h>
+#include <driver.h>
+#include <drvdb.h>
+#include <soclib_xicu.h>
+#include <soclib_icu.h>
+#include <soclib_tty.h>
+#include <soclib_timer.h>
+#include <soclib_dma.h>
+#include <soclib_block.h>
+#include <soclib_fb.h>
+#include <soclib_memc.h>
+#include <soclib_iopic.h>
+
+
+///////////////////////////////////////////////////////////////////////////////////////////
+// This global variable defines the array of supported devices and associated drivers.
+// It must be kept consistant with the enum in file drvdb.h.
+///////////////////////////////////////////////////////////////////////////////////////////
+
+static drvdb_entry_t drivers_db[DEV_TYPE_DRVID_NR] = 
+{
+	{DEV_TYPE_RAM     , "Random Access Memory"           , NULL},
+	{DEV_TYPE_TTY     , "Text Terminal Controler"        , &soclib_tty_driver},
+    {DEV_TYPE_FBF     , "Frame Buffer Controler"         , &soclib_fbf_driver},
+    {DEV_TYPE_IOB     , "I/O Bridge Component"           , &soclib_iob_driver},
+	{DEV_TYPE_IOC_BDV , "BDV Block Device Controler"     , &soclib_bdv_driver},
+	{DEV_TYPE_IOC_HBA , "HBA Block Device Controler"     , NULL},
+    {DEV_TYPE_IOC_SDC , "SDC Block Device Controler"     , NULL},
+    {DEV_TYPE_IOC_SPI , "SPI Block Device Controler"     , NULL},
+    {DEV_TYPE_IOC_RDK , "RDK Block device Controler"     , NULL},
+	{DEV_TYPE_MMC     , "L2 cache Configuration"         , &soclib_mmc_driver},
+	{DEV_TYPE_MWR_DMA , "DMA Coprocessor"                , NULL},
+	{DEV_TYPE_MWR_GCD , "GCD Coprocessor"                , NULL},
+	{DEV_TYPE_MWR_DCT , "DCT Coprocessor"                , NULL},
+	{DEV_TYPE_NIC     , "GMII-Compliant NIC Controller"  , NULL},
+	{DEV_TYPE_ROM     , "Read Only Memory"               , NULL},
+	{DEV_TYPE_CMA     , "Chained buffers DMA Controller" , NULL},
+	{DEV_TYPE_TIM     , "Real-Time Timer"                , &soclib_timer_driver},
+	{DEV_TYPE_XCU     , "Interrupt Controlier unit"      , &soclib_xicu_driver},
+	{DEV_TYPE_PIC     , "HWI to WTI translator"          , &soclib_iopic_driver},
+	{DEV_TYPE_NULL    , "End of Table Marker           " , NULL}
+};
+
+
+///////////////////////////////////////////////////
+drvdb_entry_t * drvdb_locate_byId( uint32_t drvid )
+{
+	if(drvid >= DEV_TYPE_RESERVED)
+		return NULL;
+
+	return &drivers_db[drvid];
+}
+
+//////////////////////////////////////////////
+drvdb_entry_t * drvdb_locate_byName( char * name )
+{
+	register uint32_t i;
+
+	for(i=0; drivers_db[i].id != DEV_TYPE_RESERVED; i++)
+		if(!strcmp(drivers_db[i].name, name))
+			return &drivers_db[i];
+
+	return NULL;
+}
+
+driver_t* drvdb_get_driver(uint32_t drvid)
+{
+	if(drvid >= DEV_TYPE_RESERVED)
+		return NULL;
+
+	return drivers_db[drvid].driver;
+}
+
+error_t drvdb_set_driver(uint32_t drvid, driver_t *driver)
+{
+	if(drvid >= DEV_TYPE_RESERVED)
+		return ERANGE;
+
+	drivers_db[drvid].driver = driver;
+	return 0;
+}
Index: trunk/kernel/drivers/soclib/drvdb.h
===================================================================
--- trunk/kernel/drivers/soclib/drvdb.h	(revision 1)
+++ trunk/kernel/drivers/soclib/drvdb.h	(revision 1)
@@ -0,0 +1,118 @@
+/*
+ * drvdb.h - a dictionary of supported devices and their drivers
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DRVDB_H_
+#define _DRVDB_H_
+
+#include <driver.h>
+
+
+/******************************************************************************************
+ * This enum defines the Supported Drivers types
+ * This enum must be kept consistent with the global array in drvdb.c file 
+ *****************************************************************************************/
+
+typedef enum
+{
+	SOCLIB_RAM_ID = 0,
+	SOCLIB_XICU_ID,
+	SOCLIB_TTY_ID,
+	SOCLIB_DMA_ID,
+	SOCLIB_BLKDEV_ID,
+	SOCLIB_FB_ID,
+	SOCLIB_ICU_ID,
+	SOCLIB_TIMER_ID,
+	SOCLIB_IOPIC_ID,
+	SOCLIB_MEMC_ID,
+	SOCLIB_MNIC_ID,
+	SOCLIB_CHDMA_ID,
+	SOCLIB_RESERVED_ID,
+	SOCLIB_DRVID_NR
+}soclib_drvid_t;
+
+/* Driver DataBase Entry */
+struct drvdb_entry_s;
+
+/* Entry Setters */
+#define drvdb_entry_set_id(entry,drvid)
+#define drvdb_entry_set_name(entry,name)
+#define drvdb_entry_set_info(entry,info)
+#define drvdb_entry_set_driver(entry,driver)
+
+/* Entry Getters */
+#define drvdb_entry_get_id(entry)
+#define drvdb_entry_get_name(entry)
+#define drvdb_entry_get_info(entry)
+#define drvdb_entry_get_driver(entry)
+
+
+/******************************************************************************************
+ * This structure define a Driver descriptor 
+ *****************************************************************************************/
+typedef struct drvdb_entry_s
+{
+	uint32_t   id;
+	char     * name;
+	char     * info;
+	driver_t * driver;
+}
+drvdb_entry_t;
+
+
+#define drvdb_entry_get_id(_entry)       ((_entry)->id)
+#define drvdb_entry_get_name(_entry)     ((_entry)->name)
+#define drvdb_entry_get_info(_entry)     ((_entry)->info)
+#define drvdb_entry_get_driver(_entry)   ((_entry)->driver)
+
+#define drvdb_entry_set_id(_entry,_drvid)      do {(_entry)->id = (_drvid);}      while(0)
+#define drvdb_entry_set_name(_entry,_name)     do {(_entry)->name = (_name);}     while(0)
+#define drvdb_entry_set_info(_entry,_info)     do {(_entry)->info = (_info);}     while(0)
+#define drvdb_entry_set_driver(_entry,_driver) do {(_entry)->driver = (_driver);} while(0)
+
+/******************************************************************************************
+ * This function returns a pointer on driver descriptor from its index.
+ * @ drvid   : index in the drivers descriptors array.
+ *****************************************************************************************/
+drvdb_entry_t * drvdb_locate_byId( uint32_t drvid );
+
+/******************************************************************************************
+ * This function returns a pointer on driver descriptor from its name.
+ * @ name    : name in the drivers descriptors array.
+ *****************************************************************************************/
+drvdb_entry_t * drvdb_locate_byName( char * name );
+
+/******************************************************************************************
+ * This function register a driver pointer in the driver descriptors array.
+ * @ drvid    : index in the drivers descriptors array.
+ * @ driver   : function pointer to be registered.
+ *****************************************************************************************/
+error_t drvdb_set_driver( uint32_t   drvid, 
+                          driver_t * driver );
+
+/******************************************************************************************
+ * This function returns a driver pointer from the driver index
+ * @ drvid    : index in the drivers descriptors array.
+ * @ returns  function pointer to be registered.
+ *****************************************************************************************/
+driver_t * drvdb_get_driver( uint32_t drvid );
+
+#endif	/* _DRVDB_H_ */
Index: trunk/kernel/drivers/soclib/soclib_bdv.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_bdv.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_bdv.c	(revision 1)
@@ -0,0 +1,149 @@
+/*
+ * soclib_bdv.c - soclib simple block device driver implementation.
+ *
+ * Author     Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <device.h>
+#include <dev_ioc.h>
+#include <soclib_bdv.h>
+#include <thread.h>
+#include <spinlock.h>
+
+
+/////////////////////////////////////
+void soclib_bdv_init( xptr_t dev_xp )
+{
+    // get IOC device descriptor cluster and local pointer
+    cxy_t      dev_cxy  = GET_CXY( dev_xp );
+    device_t * dev_ptr  = (device_t *)GET_PTR( dev_xp );
+  
+    // get extended pointer on SOCLIB_BDV peripheral base address
+	xptr_t  bdv_xp = hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get hardware device cluster and local pointer
+    cxy_t      bdv_cxy  = GET_CXY( bdv_xp );
+    uint32_t * bdv_ptr  = (uint32_t *)GET_PTR( bdv_xp );
+
+    // get block_size and block_count  
+	uint32_t block_size = hal_remote_lw( XPTR( bdv_cxy , bdv_ptr + BDV_BLOCK_SIZE_REG ) );
+	uint32_t block_count = hal_remote_lw( XPTR( bdv_cxy , bdv_ptr + BDV_SIZE_REG ) );
+
+    // set IOC device descriptor extension
+    hal_remote_sw( XPTR( dev_cxy , &dev_ptr->ext.ioc.size  ) , block_size );
+    hal_remote_sw( XPTR( dev_cxy , &dev_ptr->ext.ioc.count ) , block_count );
+
+} // end soclib_bdv_init()
+
+
+//////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_bdv_command( xptr_t th_xp )
+{
+    uint32_t   to_mem;       // command argument
+    uint32_t   lba;          // command argument
+    uint32_t   count;        // command argument
+    xptr_t     buf_xp;       // command argument
+    xptr_t     dev_xp;       // command argument
+
+    // get client thread cluster and local pointer
+    cxy_t      th_cxy = GET_CXY( th_xp );
+    thread_t * th_ptr = (thread_t *)GET_PTR( th_xp );
+
+    // get command arguments and extended pointer on IOC device
+    to_mem =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.to_mem ) );
+    lba    =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.lba    ) );
+    count  =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.ioc.count  ) );
+    buf_xp = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.ioc.buf_xp ) );
+    dev_xp = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.ioc.dev_xp ) );
+
+    // get IOC device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on SOCLIB-BDV peripheral
+    xptr_t     bdv_xp = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get SOCLIB_BDV device cluster and local pointer
+    cxy_t      bdv_cxy = GET_CXY( bdv_xp );
+    uint32_t * bdv_ptr = (uint32_t *)GET_PTR( bdv_xp );
+
+    // split buffer address in two 32 bits words
+    uint32_t   buf_lsb = (uint32_t)(buf_xp);
+    uint32_t   buf_msb = (uint32_t)(buf_xp>>32);
+
+    // get access type
+    uint32_t   type =  to_mem ? BDV_OP_READ : BDV_OP_WRITE; 
+
+    // set SOCLIB_BDV registers to start one I/O operation
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_IRQ_ENABLE_REG ) , 1       );
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_BUFFER_REG     ) , buf_lsb ); 
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_BUFFER_EXT_REG ) , buf_msb ); 
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_LBA_REG        ) , lba     );
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_COUNT_REG      ) , count   );
+    hal_remote_sw( XPTR( bdv_cxy , bdv_ptr + BDV_OP_REG         ) , type    );
+
+    // Block and deschedule server thread
+    thread_block( CURRENT_THREAD , THREAD_BLOCKED_DEV_ISR );
+    sched_yield();
+    
+} // end soclib_bdv_cmd()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_bdv_isr( device_t * dev )
+{
+    // get extended pointer on client thread
+    xptr_t root = XPTR( local_cxy , &dev->wait_root );
+    xptr_t client_xp = XLIST_FIRST_ELEMENT( root , thread_t , wait_list );
+
+    // get extended pointer on server thread
+    xptr_t server_xp = XPTR( local_cxy , &dev->server );
+
+    // get client thread cluster and local pointer
+    cxy_t      client_cxy = GET_CXY( client_xp );
+    thread_t * client_ptr = (thread_t *)GET_PTR( client_xp );
+
+    // get SOCLIB_BDV device cluster and local pointer
+    cxy_t      bdv_cxy  = GET_CXY( dev->base );
+    uint32_t * bdv_ptr  = (uint32_t *)GET_PTR( dev->base );
+
+    // get BDV status register and acknowledge IRQ
+	uint32_t status = hal_remote_lw( XPTR( bdv_cxy , bdv_ptr + BDV_STATUS_REG ) );   
+
+    // set operation status in command
+	if((status != BDV_READ_SUCCESS) && (status != BDV_WRITE_SUCCESS)) 
+    {
+        hal_remote_sw( XPTR( client_cxy , &client_ptr->dev.ioc.error ) , 1 );
+    }
+	else
+    {
+        hal_remote_sw( XPTR( client_cxy , &client_ptr->dev.ioc.error ) , 0 );
+    }
+
+    // unblock server thread 
+    thread_unblock( server_xp , THREAD_BLOCKED_DEV_ISR );
+
+    // unblock client thread
+    thread_unblock( client_xp , THREAD_BLOCKED_IO );
+
+} // end soclib_bdv_isr()
+
+
+
